#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double

int inf = (int)1000 * 1000 * 1000 * 1000 * 1000 * 1000 + 100;
// int inf = (int)1000 * 1000 * 1000 + 100;

/*
#pragma optimize("O3")
#pragma optimize("avx,avx2,bmi,bmi2")
*/

mt19937_64 rnd(228);

void print(vector <int> a) {
    for (int i = 0; i < a.size(); i ++) {
        cout << a[i] << " ";
    }
    cout << '\n';
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> b(n);
    for (int i = 0; i < n; i ++) {
        cin >> a[i] >> b[i];
    }

    vector <int> p(n);

    for (int i = 0; i < n; i ++) {
        cin >> p[i];
    }

    vector <int> pref_mx(n, 0);
    int cnt = 0;
    for (int i = 0; i < n; i ++) {
        cnt += a[i];
        if (i > 0) {
            pref_mx[i] = max(pref_mx[i - 1], cnt);
        }
        else {
            pref_mx[i] = max((int)0, cnt);
        }
    }
    vector <int> suf_mx(n, 0);
    cnt = 0;
    for (int i = n - 1; i >= 0; i --) {
        cnt += a[i] * i;
        if (i < n - 1) {
            suf_mx[i] = max(suf_mx[i + 1], cnt);
        }
        else {
            suf_mx[i] = max((int)0, cnt);
        }
    }

    int ans = 0;
    for (int i = -1; i < n; i ++) {
        if (i == -1) {
            ans = max(ans, suf_mx[i + 1]);
        }
        else if (i == n - 1) {
            ans = max(ans, pref_mx[i]);
        }
        else {
            ans = max(ans, pref_mx[i] + suf_mx[i + 1]);
        }
    }

    cout << ans << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int _ = 1;
    // cin >> _;
    while (_ --) {
        solve();
    }
}